import { pipe, compose, composeRight, addIndex, repeatF, eq, id, ifOk, ifPredicate, recurry, always } from 'stick-js/es';
import { length } from 'alleycat-js/es/general';
export var N = always(null);
export var flatMap = recurry(2)(function (f) {
  return function (xs) {
    return xs.flatMap(f);
  };
});
export var flatMapX = addIndex(flatMap);
var flatten = flatMap(id);
export var flatRepeatF = recurry(2)(function (f) {
  return function (o) {
    return pipe(repeatF(f)(o), flatten);
  };
});
export var isEmptyList = composeRight(length, eq(0));
export var ifEmptyList = pipe(isEmptyList, ifPredicate);
export var discardStackTrace = function discardStackTrace(e) {
  return pipe(e.message, ifOk(id, function () {
    return e;
  }));
};
export var randInt = function randInt(x) {
  return Math.floor(Math.random() * x);
};
export var randBool = function randBool() {
  return Boolean(randInt(2));
};
export var base64decodeAsU8Array = function base64decodeAsU8Array(x) {
  return new Uint8Array(Buffer.from(x, 'base64'));
};
export var base64encodeFromU8Array = function base64encodeFromU8Array(x) {
  return Buffer.from(x).toString('base64');
};